/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("cordova-plugin-file.FileReader",function(t,r,e){function s(t){l.defineGetterSetter(f.prototype,t,function(){return this._realReader[t]||null},function(r){this._realReader[t]=r})}function i(t,r){if(t.readyState===f.LOADING)throw new h(h.INVALID_STATE_ERR);return t._result=null,t._error=null,t._progress=0,t._readyState=f.LOADING,"string"!=typeof r.localURL?(t._localURL="",!0):(t._localURL=r.localURL,void(t.onloadstart&&t.onloadstart(new u("loadstart",{target:t}))))}function o(t,r,e,s,i,d){if(this._readyState!==f.DONE){var l=f.READ_CHUNK_SIZE;if("readAsDataURL"===t&&(l="windows"===cordova.platformId?s:f.READ_CHUNK_SIZE-f.READ_CHUNK_SIZE%3+3),"undefined"!=typeof d&&(i(d),this._progress=Math.min(this._progress+l,s),"function"==typeof this.onprogress&&this.onprogress(new u("progress",{loaded:this._progress,total:s}))),"undefined"==typeof d||this._progress<s){var h=[this._localURL,e+this._progress,e+this._progress+Math.min(s-this._progress,l)];r&&h.splice(1,0,r),a(o.bind(this,t,r,e,s,i),n.bind(this),"File",t,h)}else this._readyState=f.DONE,"function"==typeof this.onload&&this.onload(new u("load",{target:this})),"function"==typeof this.onloadend&&this.onloadend(new u("loadend",{target:this}))}}function n(t){this._readyState!==f.DONE&&(this._readyState=f.DONE,this._result=null,this._error=new h(t),"function"==typeof this.onerror&&this.onerror(new u("error",{target:this})),"function"==typeof this.onloadend&&this.onloadend(new u("loadend",{target:this})))}var a=t("cordova/exec"),d=t("cordova/modulemapper"),l=t("cordova/utils"),h=t("./FileError"),u=t("./ProgressEvent"),_=d.getOriginalSymbol(window,"FileReader"),f=function(){this._readyState=0,this._error=null,this._result=null,this._progress=null,this._localURL="",this._realReader=_?new _:{}};f.READ_CHUNK_SIZE=262144,f.EMPTY=0,f.LOADING=1,f.DONE=2,l.defineGetter(f.prototype,"readyState",function(){return this._localURL?this._readyState:this._realReader.readyState}),l.defineGetter(f.prototype,"error",function(){return this._localURL?this._error:this._realReader.error}),l.defineGetter(f.prototype,"result",function(){return this._localURL?this._result:this._realReader.result}),s("onloadstart"),s("onprogress"),s("onload"),s("onerror"),s("onloadend"),s("onabort"),f.prototype.abort=function(){return _&&!this._localURL?this._realReader.abort():(this._result=null,void(this._readyState!==f.DONE&&this._readyState!==f.EMPTY&&(this._readyState=f.DONE,"function"==typeof this.onabort&&this.onabort(new u("abort",{target:this})),"function"==typeof this.onloadend&&this.onloadend(new u("loadend",{target:this})))))},f.prototype.readAsText=function(t,r){if(i(this,t))return this._realReader.readAsText(t,r);var e=r||"UTF-8",s=t.end-t.start;o.bind(this)("readAsText",e,t.start,s,function(t){0===this._progress&&(this._result=""),this._result+=t}.bind(this))},f.prototype.readAsDataURL=function(t){if(i(this,t))return this._realReader.readAsDataURL(t);var r=t.end-t.start;o.bind(this)("readAsDataURL",null,t.start,r,function(t){var r=t.indexOf(",");0===this._progress?this._result=t:this._result+=t.substring(r+1)}.bind(this))},f.prototype.readAsBinaryString=function(t){if(i(this,t))return this._realReader.readAsBinaryString(t);var r=t.end-t.start;o.bind(this)("readAsBinaryString",null,t.start,r,function(t){0===this._progress&&(this._result=""),this._result+=t}.bind(this))},f.prototype.readAsArrayBuffer=function(t){if(i(this,t))return this._realReader.readAsArrayBuffer(t);var r=t.end-t.start;o.bind(this)("readAsArrayBuffer",null,t.start,r,function(t){var e=new Uint8Array(0===this._progress?r:this._result);e.set(new Uint8Array(t),this._progress),this._result=e.buffer}.bind(this))},e.exports=f});