/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2016 Exponent
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * Based on "tough-cookie-web-storage-store" v1.0.0
 * Thanks James Ide: https://github.com/exponentjs/tough-cookie-web-storage-store
 *
 * Modified by Sefa Ilkimen for cordova plugin integration
 *
 */

cordova.define("cordova-plugin-advanced-http.local-storage-store",function(t,o,e){e.exports=function(t,o){function e(o,e){t.Store.call(this),this._storage=o,this._storeKey=e||"__cookieStore__",this.synchronous=!0}return e.prototype=Object.create(t.Store),e.prototype.findCookie=function(e,r,n,i){var u=this._readStore(),s=o.get(u,[e,r,n],null);i(null,t.Cookie.fromJSON(s))},e.prototype.findCookies=function(e,r,n){if(!e)return void n(null,[]);var i=this,u=[],s=this._readStore(),a=t.permuteDomain(e)||[e];a.forEach(function(t){if(s[t]){var e=Object.keys(s[t]);null!=r&&(e=e.filter(function(t){return i._isOnPath(t,r)})),e.forEach(function(e){Array.prototype.push.apply(u,o.values(s[t][e]))})}}),u=u.map(function(o){return t.Cookie.fromJSON(o)}),n(null,u)},e.prototype._isOnPath=function(t,o){return t?t===o?!0:0!==o.indexOf(t)?!1:"/"!==t[t.length-1]&&"/"!==o[t.length]?!1:!0:!1},e.prototype.putCookie=function(t,e){var r=this._readStore();o.set(r,[t.domain,t.path,t.key],t),this._writeStore(r),e(null)},e.prototype.updateCookie=function(t,o,e){this.putCookie(o,e)},e.prototype.removeCookie=function(t,e,r,n){var i=this._readStore();o.unset(i,[t,e,r]),this._writeStore(i),n(null)},e.prototype.removeCookies=function(t,e,r){var n=this._readStore();null==e?o.unset(n,[t]):o.unset(n,[t,e]),this._writeStore(n),r(null)},e.prototype.getAllCookies=function(e){var r=[],n=this._readStore();Object.keys(n).forEach(function(t){Object.keys(n[t]).forEach(function(e){Array.protype.push.apply(r,o.values(n[t][e]))})}),r=r.map(function(o){return t.Cookie.fromJSON(o)}),r.sort(function(t,o){return(t.creationIndex||0)-(o.creationIndex||0)}),e(null,r)},e.prototype._readStore=function(){var t=this._storage.getItem(this._storeKey);if(null!==t)try{return JSON.parse(t)}catch(o){}return{}},e.prototype._writeStore=function(t){this._storage.setItem(this._storeKey,JSON.stringify(t))},e}});