/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("cordova-plugin-file.FileWriter",function(t,e,r){var n=t("cordova/exec"),o=t("./FileError"),i=t("./FileReader"),a=t("./ProgressEvent"),s=function(t){this.fileName="",this.length=0,t&&(this.localURL=t.localURL||t,this.length=t.size||0),this.position=0,this.readyState=0,this.result=null,this.error=null,this.onwritestart=null,this.onprogress=null,this.onwrite=null,this.onwriteend=null,this.onabort=null,this.onerror=null};s.INIT=0,s.WRITING=1,s.DONE=2,s.prototype.abort=function(){if(this.readyState===s.DONE||this.readyState===s.INIT)throw new o(o.INVALID_STATE_ERR);this.error=new o(o.ABORT_ERR),this.readyState=s.DONE,"function"==typeof this.onabort&&this.onabort(new a("abort",{target:this})),"function"==typeof this.onwriteend&&this.onwriteend(new a("writeend",{target:this}))},s.prototype.write=function(t,e){var r,w=this,f="undefined"!=typeof window.Blob&&"undefined"!=typeof window.ArrayBuffer,d="windows8"===cordova.platformId||"windows"===cordova.platformId;if(t instanceof File||!d&&f&&t instanceof Blob){var h=new i;return h.onload=function(){s.prototype.write.call(w,this.result,!0)},h.onerror=function(){w.readyState=s.DONE,w.error=this.error,"function"==typeof w.onerror&&w.onerror(new a("error",{target:w})),"function"==typeof w.onwriteend&&w.onwriteend(new a("writeend",{target:w}))},this.readyState=s.WRITING,void(f?h.readAsArrayBuffer(t):h.readAsText(t))}if(r=f&&t instanceof ArrayBuffer,r&&"windowsphone"===cordova.platformId&&(t=Array.apply(null,new Uint8Array(t))),this.readyState===s.WRITING&&!e)throw new o(o.INVALID_STATE_ERR);this.readyState=s.WRITING;var l=this;"function"==typeof l.onwritestart&&l.onwritestart(new a("writestart",{target:l})),n(function(t){l.readyState!==s.DONE&&(l.position+=t,l.length=l.position,l.readyState=s.DONE,"function"==typeof l.onwrite&&l.onwrite(new a("write",{target:l})),"function"==typeof l.onwriteend&&l.onwriteend(new a("writeend",{target:l})))},function(t){l.readyState!==s.DONE&&(l.readyState=s.DONE,l.error=new o(t),"function"==typeof l.onerror&&l.onerror(new a("error",{target:l})),"function"==typeof l.onwriteend&&l.onwriteend(new a("writeend",{target:l})))},"File","write",[this.localURL,t,this.position,r])},s.prototype.seek=function(t){if(this.readyState===s.WRITING)throw new o(o.INVALID_STATE_ERR);(t||0===t)&&(this.position=0>t?Math.max(t+this.length,0):t>this.length?this.length:t)},s.prototype.truncate=function(t){if(this.readyState===s.WRITING)throw new o(o.INVALID_STATE_ERR);this.readyState=s.WRITING;var e=this;"function"==typeof e.onwritestart&&e.onwritestart(new a("writestart",{target:this})),n(function(t){e.readyState!==s.DONE&&(e.readyState=s.DONE,e.length=t,e.position=Math.min(e.position,t),"function"==typeof e.onwrite&&e.onwrite(new a("write",{target:e})),"function"==typeof e.onwriteend&&e.onwriteend(new a("writeend",{target:e})))},function(t){e.readyState!==s.DONE&&(e.readyState=s.DONE,e.error=new o(t),"function"==typeof e.onerror&&e.onerror(new a("error",{target:e})),"function"==typeof e.onwriteend&&e.onwriteend(new a("writeend",{target:e})))},"File","truncate",[this.localURL,t])},r.exports=s});